// HASH GBC emu 
// (c) dox 1999
// dox@emugaming.com

#include <stdio.h>
#include <windows.h>
#include "c:\mssdk\include\ddraw.h"
#include "utils.cpp"
#include "memmap.cpp"
#include "cpulib.h"
#include "gfx.cpp"
#include "directdraw.cpp"
#include "mainloop.cpp"
#include "df.h"


LRESULT CALLBACK winproc(HWND,UINT,WPARAM,LPARAM);

int WINAPI WinMain(HINSTANCE in1,HINSTANCE,LPSTR,int winm)
{
 MSG message;
 WNDCLASS wndcl;
 wndcl.style=0;
 wndcl.hInstance=in1;
 wndcl.lpszClassName=cname;
 wndcl.lpfnWndProc=winproc;
 wndcl.hIcon=LoadIcon(in1,MAKEINTRESOURCE(115));
 wndcl.hCursor=LoadCursor(NULL,IDC_ARROW);
 wndcl.lpszMenuName="menu1";
 wndcl.cbClsExtra=0;
 wndcl.cbWndExtra=0;
 wndcl.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
 if(!RegisterClass(&wndcl)) 
  return(-1);
 window=CreateWindowEx(0,cname,wname,WS_SIZEBOX|WS_OVERLAPPEDWINDOW|WS_VISIBLE,50,50,160*2,144*2,NULL,NULL,in1,NULL);
 ShowWindow(window,winm);
 UpdateWindow(window);

  DF_init();	// *******

 while((GetMessage(&message,NULL,0,0)))
  DispatchMessage(&message);
 f_stopped=1;
 thr_f=0;
 Sleep(100);
 if(cart!=NULL)
  delete cart;
 ReleaseAllObjects();

 DF_done();		// *******


 return message.wParam;
}

LRESULT CALLBACK winproc(HWND window,UINT message,WPARAM wparam,LPARAM lparam)
{
 switch(message)
 {
  case WM_CREATE:
   start_dx();
   make_pix();
   reset();
   f_stopped=1;
   th=CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)main_loop,0,0,&tid);
   Sleep(100);
   strcpy(dirload,".");
   RECT R;
   GetClientRect(window,(LPRECT)&R);
   DW=320-(R.right-R.left);
   DH=288-(R.bottom-R.top);
   MoveWindow(window,50,50,320+DW,288+DH,TRUE);
  break;
  case WM_COMMAND:
   switch(LOWORD(wparam))
   {
	case 40001:
	 load_file(window);
	break;
	case 40022:
     MoveWindow(window,50,50,160+DW,144+DH,TRUE);
	break;
	case 40023:
	 MoveWindow(window,50,50,2*160+DW,2*144+DH,TRUE);
	break;
	case 40024:
	 MoveWindow(window,50,50,3*160+DW,3*144+DH,TRUE);
	break;
	case 40025:
	 MoveWindow(window,50,50,4*160+DW,4*144+DH,TRUE);
	break;
	case 40006:
     PostMessage(window,WM_DESTROY,0,0);
	break;
   }
 break;
 case WM_DESTROY:
  PostQuitMessage(0);
 return 0;
 case WM_KEYDOWN:
  switch(wparam)
  {	
  case 'Z':
   k_b=0;
  break;
  case 'X':
   k_a=0;
  break;
  case 'A':
   k_start=0;
  break;
  case 'S':
   k_select=0;
  break;
  case VK_UP:
   k_up=0;
  break;
  case VK_DOWN:
   k_down=0;
  break;
  case VK_LEFT:
   k_left=0;
  break;
  case VK_RIGHT:
   k_right=0;
  break;
  case 'P':
   f_stopped^=1;
  break;
  case VK_ESCAPE:
   PostMessage(window,WM_DESTROY,0,0);
  break;
 }
 break;
 case WM_KEYUP:
  switch(wparam)
  {
   case 'Z':
    k_b=1;
   break;
   case 'X':
	k_a=1;
   break;
   case 'A':
	k_start=1;
   break;
   case 'B':
	k_select=1;
   break;
   case VK_UP:
	k_up=1;
   break;
   case VK_DOWN:
	k_down=1;
   break;
   case VK_LEFT:
	k_left=1;
   break;
   case VK_RIGHT:
	k_right=1;
   break;
  }
  break;
 default:
 return DefWindowProc(window,message,wparam,lparam);
 }
	return 0;
}
