#include "df.h"

int test1, test2, test3, test4, test5;



void set_bank(DWORD number)
{
	if(!number)  number=1; number%=srom; if(!number) number=1; addr_bank=number*0x4000-0x4000;
}

void set_bank_mbc1_hi(DWORD data)
{
	data=(data&3)<<5; rom_priv&=31; rom_priv|=data; set_bank(rom_priv);
}

void set_bank_mbc1_lo(DWORD data)
{
	rom_priv&=96; rom_priv|=data; set_bank(rom_priv);
}

void set_bank_mbc5_lo(DWORD data)
{
	rom_priv&=256;  rom_priv|=data; set_bank(rom_priv);
}

void set_bank_mbc5_hi(DWORD data)
{
	if(data&1)  rom_priv|=256; else  rom_priv&=255; set_bank(rom_priv);
}

void set_ff0f(BYTE number)
{
	if((m_iram[0xffff]&number))  m_iram[0xff0f]|=number;
}

BYTE readmem(WORD address)
{
	if (cart==NULL) return 0;


	/*
	w A001 01
	w A002 00
	w A003 10
	w A004 05
	w A005 80
	*/
	// ********
	unsigned char r = rand();
	//if (!sram_enable)
	if (cambank) if ((address>=0xA000) && (address<0xC000))
	{
		if (address == 0xA000) return 0;	// ready

		return tiles[0][0][0][address & 0xFFF];	// >> (rand()&1) << (rand()&1); // ^ test1 ^ test2 ^ test4 ^ test5;	// 256*16
		// 1+2: brightness? (1=MSB, 2=LSB)
		// 3: counter?
		// 4: fixed?
		// 5

		//Log('r', address, r);
		//return r & 15;
	}


	if (address<0x8000)
	{
		if((memc==ROM)||(address<0x4000))
			return cart[address];
		else
			return cart[address+addr_bank];
	}
	
	if ((address>=0xe000)&&(address<0xfe00)) address-=0x2000;	

	if (gb_mode==CGB)
	{
		if (((m_iram[0xff4f])&1)&&(address>=0x8000)&&(address<0xa000)) return m_iram2[address];
		if((address>=0xd000)&&(address<=0xdfff))
		{
			BYTE cr=(m_iram[0xff70])&7;
			if (cr==0) cr=1;
			return m_cgbram[4096*cr+address-0xd000];
		}
 
		switch(address)
		{
			case 0xff69:
				return palramb[(m_iram[0xff68])&63];
				break;
			case 0xff6b:
				return palramo[(m_iram[0xff68])&63];
				break;
		}
	}
  
	if (sram&&(address>=0xa000)&&(address<0xc000)) return m_ram[address-0xa000+n_ram*0x8912];

	return m_iram[address];
}


void writemem(WORD address,WORD data)
{
	if (cart==NULL) return;

	
	// ********
	//if (!sram_enable)
	if (cambank) if (address>=0xA000 && address<0xC000)
	{
		if (address == 0xA001) test1 = data;
		if (address == 0xA002) test2 = data;
		if (address == 0xA003) test3 = data;
		if (address == 0xA004) test4 = data;
		if (address == 0xA005) test5 = data;

		//Log('w', address, data&0xff);
	}


	if (address<0x8000)
	{
		if ((address>=0x0000)&&(address<=0x1fff))	// ******
		{
			sram_enable = (data&0xff == 0x0a);
		}

		switch (memc)
		{
			case MBC3:
				if ((address>=0x2000)&&(address<=0x3fff))
				{
					if (data==0) data=1;
					set_bank(data);
					return;
				}
				if ((address>=0x4000)&&(address<0x6000))
				{
					cambank = (data >= 0x10);
					n_ram=data&3;
					return;
				}
				break;

			case MBC1:
				if ((address>=0x6000)&&(address<0x8000))
				{
					mbc1_type=data&1;
					return;
				}
				if ((address>=0x2000)&&(address<0x4000))
				{
					data&=31;
					set_bank_mbc1_lo(data);
					return;
				}
				if ((address>=0x4000)&&(address<0x6000))
				{
					if (mbc1_type)
					{
						cambank = (data >= 0x10);
						n_ram=data&3;
						return;
					}
					{
						set_bank_mbc1_hi(data);
						return;
					}
				}
				break;

			case MBC5: 	
				if ((address>=0x2000)&&(address<=0x2fff))
				{
					set_bank_mbc5_lo(data);
					return;
				}
				if ((address>=0x3000)&&(address<=0x3fff))
				{
					set_bank_mbc5_hi(data);
					return;
				}
				if ((address>=0x4000)&&(address<=0x5fff))
				{
					cambank = (data >= 0x10);
					n_ram=data&15;
					return;
				}
				break;

			case MBC2:
				if ((address>=0x2000)&&(address<0x4000)&&(address&256))
				{
					data&=15;
					set_bank(data);
					return;
				}
				break;
		}
	}	// < 0x8000


	// CGB
	if (gb_mode==CGB)
	{
		if ((address>=0xd000)&&(address<=0xdfff))
		{
			BYTE cr=(m_iram[0xff70])&7;
			if (cr==0) cr=1;
			m_cgbram[4096*cr+address-0xd000]=(BYTE)data;
			return;
		}
		if (address==0xff55)
		{
			if (!(data&128))
			{
				if (hdma)
					hdma=0;
				else
				{
					adr_s=((m_iram[0xff51])<<8)|(m_iram[0xff52]&240);
					adr_p=((((m_iram[0xff53])&31)<<8)|(m_iram[0xff54]&240))|0x8000;
					for (long ji=0;ji<((data&127)*16+16);ji++)
						writemem(adr_p++,readmem(adr_s++));
					cnumber+=data*32+928/gb_speed;
					data=0xff;
				}
			}
			else
			{
				data&=127;
				if (m_iram[0xff40]&128)
				{
					hdma=1;
					hdma_count=data+1;
					adr_s=((m_iram[0xff51])<<8)|(m_iram[0xff52]&240);
					adr_p=((((m_iram[0xff53])&31)<<8)|(m_iram[0xff54]&240))|0x8000;
				}
			}
		}


		if ((address>=0x8000)&&(address<0xa000)&&((m_iram[0xff4f]&1)))
		{
			m_iram2[address]=(BYTE)data;
			return;
		}

		switch(address)
		{
			case 0xff69:
				palramb[(m_iram[0xff68])&63]=(BYTE)data;
				if (m_iram[0xff68]&1)
				{
 					pal_b[((m_iram[0xff68])&56)>>3][((m_iram[0xff68])&6)>>1][0]=(data&124)<<1;
					pal_b[((m_iram[0xff68])&56)>>3][((m_iram[0xff68])&6)>>1][1]&=63;
					pal_b[((m_iram[0xff68])&56)>>3][((m_iram[0xff68])&6)>>1][1]|=(data<<6);
				}
				else
				{
 					pal_b[((m_iram[0xff68])&56)>>3][((m_iram[0xff68])&6)>>1][2]=(data&31)<<3;
					pal_b[((m_iram[0xff68])&56)>>3][((m_iram[0xff68])&6)>>1][1]&=192;
					pal_b[((m_iram[0xff68])&56)>>3][((m_iram[0xff68])&6)>>1][1]|=(data&224)>>2;
				}
				pal_dx_b[((m_iram[0xff68])&56)>>3][((m_iram[0xff68])&6)>>1]=(((pal_b[((m_iram[0xff68])&56)>>3][((m_iram[0xff68])&6)>>1][2])>>(8-dx_r))<<dx_sr)|(((pal_b[((m_iram[0xff68])&56)>>3][((m_iram[0xff68])&6)>>1][1])>>(8-dx_g))<<dx_sg)|(((pal_b[((m_iram[0xff68])&56)>>3][((m_iram[0xff68])&6)>>1][0])>>(8-dx_b))<<dx_sb);
				if (m_iram[0xff68]&128)
				{
 					m_iram[0xff68]&=0x3f;
					m_iram[0xff68]++;
					m_iram[0xff68]|=128;
				}
				break;

			case 0xff6b:
				palramo[(m_iram[0xff6a])&63]=(BYTE)data;
				if(m_iram[0xff6a]&1)
				{
 					pal_o[((m_iram[0xff6a])&56)>>3][((m_iram[0xff6a])&6)>>1][0]=(data&124)<<1;
					pal_o[((m_iram[0xff6a])&56)>>3][((m_iram[0xff6a])&6)>>1][1]&=63;
					pal_o[((m_iram[0xff6a])&56)>>3][((m_iram[0xff6a])&6)>>1][1]|=data<<6;
				}
				else 
				{
					pal_o[((m_iram[0xff6a])&56)>>3][((m_iram[0xff6a])&6)>>1][2]=(data&31)<<3;
					pal_o[((m_iram[0xff6a])&56)>>3][((m_iram[0xff6a])&6)>>1][1]&=192;
					pal_o[((m_iram[0xff6a])&56)>>3][((m_iram[0xff6a])&6)>>1][1]|=(data&224)>>2;
				}
				pal_dx_o[((m_iram[0xff6a])&56)>>3][((m_iram[0xff6a])&6)>>1]=(((pal_o[((m_iram[0xff6a])&56)>>3][((m_iram[0xff6a])&6)>>1][2])>>(8-dx_r))<<dx_sr)|(((pal_o[((m_iram[0xff6a])&56)>>3][((m_iram[0xff6a])&6)>>1][1])>>(8-dx_g))<<dx_sg)|(((pal_o[((m_iram[0xff6a])&56)>>3][((m_iram[0xff6a])&6)>>1][0])>>(8-dx_b))<<dx_sb);
				if (m_iram[0xff6a]&128)
				{
					m_iram[0xff6a]&=0x3f;
					m_iram[0xff6a]++;
					m_iram[0xff6a]|=128;
				}
				break;
		}
	}	// CGB

	// mirror
	if ((address>=0xe000)&&(address<0xfe00)) address-=0x2000;

	// I/O
	if (address>=0xff00) switch(address)
	{
		case 0xff00:
			if (data==3)
				data=0xff;
			else
			{
				if((data&0x30)==0x30)
					data=0xff;
				else
				{
					if ((data&0x30)==0x20)
					{
						data=0x20|(k_down<<3)|(k_up<<2)|(k_left<<1)|k_right;
					}
					else
					{
						if((data&0x30)==0x10)
							data=0x10|(k_start<<3)|(k_select<<2)|(k_b<<1)|k_a;
					}
				}
			}
			data|=0xc0;
			break;

		case 0xff02: 
			if ((data&128)&&(data&1)) sio_count=8;
			data|=126;
			break;
		
		case 0xff04:
			data=0;
			n_ff04=0;
			break;

		case 0xff07:
			if(data&4)
			{
				c_count=0;
				t_count=m_iram[0xff06];;
			}
			break;
		
		case 0xff40:
			if(!(data&128))
				vbioff_count=1;
			else
				if(!(m_iram[0xff40]&128))
				{
					old_mode=5;
					cycles=1;
					cur_c=2;
					nr_t=0;
				}
			break;

		case 0xff0f:
			if(data&16) set_ff0f(16);
			if (data&8) set_ff0f(8);
			if (data&4) set_ff0f(4);
			if (data&2) set_ff0f(2);
			if (data&1) set_ff0f(1);
			break;

		case 0xff47:
			if (gb_mode!=CGB)
			{
				gb_mode=CGB;
				writemem(0xff68,128);
				writemem(0xff69,(colors[data&3])&0xff);
				writemem(0xff69,(colors[data&3])>>8);
				writemem(0xff69,(colors[(data&0xc)>>2])&0xff);
				writemem(0xff69,(colors[(data&0xc)>>2])>>8);
				writemem(0xff69,(colors[(data&0x30)>>4])&0xff);
				writemem(0xff69,(colors[(data&0x30)>>4])>>8);
				writemem(0xff69,(colors[(data&0xc0)>>6])&0xff);
				writemem(0xff69,(colors[(data&0xc0)>>6])>>8);
				gb_mode=DMG;
			}
			break;

		case 0xff48: 
			if (gb_mode!=CGB)
			{
				gb_mode=CGB;
				writemem(0xff6a,128);
				writemem(0xff6b,(colors[data&3])&0xff);
				writemem(0xff6b,(colors[data&3])>>8);
				writemem(0xff6b,(colors[(data&0xc)>>2])&0xff);
				writemem(0xff6b,(colors[(data&0xc)>>2])>>8);
				writemem(0xff6b,(colors[(data&0x30)>>4])&0xff);
				writemem(0xff6b,(colors[(data&0x30)>>4])>>8);
				writemem(0xff6b,(colors[(data&0xc0)>>6])&0xff);
				writemem(0xff6b,(colors[(data&0xc0)>>6])>>8);
				gb_mode=DMG;
			}
			break;

		case 0xff49: 
			if (gb_mode!=CGB)
			{
				gb_mode=CGB;
				writemem(0xff6a,128+8);
				writemem(0xff6b,(colors[data&3])&0xff);
				writemem(0xff6b,(colors[data&3])>>8);
				writemem(0xff6b,(colors[(data&0xc)>>2])&0xff);
				writemem(0xff6b,(colors[(data&0xc)>>2])>>8);
				writemem(0xff6b,(colors[(data&0x30)>>4])&0xff);
				writemem(0xff6b,(colors[(data&0x30)>>4])>>8);
				writemem(0xff6b,(colors[(data&0xc0)>>6])&0xff);
				writemem(0xff6b,(colors[(data&0xc0)>>6])>>8);
				gb_mode=DMG;
			}
			break;

		case 0xff41:
			if((!mode)||(mode==1))
			{
				m_iram[0xff0f]|=2;
				set_ff0f(2);
			}
			break;

		case 0xff46: 
			WORD skad=data<<8;
			WORD ile=0xa0;
			WORD gdzie=0xfe00;
			for (int pi=0;pi<ile;pi++)
				m_iram[gdzie++]=readmem(skad++);
			break;
	}	// I/O

	// sram
	if (sram&&(address>=0xa000)&&(address<0xc000))
		m_ram[address-0xa000+n_ram*0x8912]=(BYTE)data;
	else
		m_iram[address]=(BYTE)data;
}

void push_pc()
{
 _asm
 {
  mov ax,gbr_pc
  dec gbr_sp
  xchg ah,al
  push eax
  push dword ptr gbr_sp
  call writemem
  lea esp,[esp+8]
  mov ax,gbr_pc
  push eax
  dec gbr_sp
  push dword ptr gbr_sp
  call writemem
  lea esp,[esp+8]
 }
}
